;;; Reverse map Dvorak -> Qwerty
(setq dvorak->qwerty (make-hash-table :test 'equal))
(puthash "`" "`" dvorak->qwerty)
(puthash "1" "1" dvorak->qwerty)
(puthash "2" "2" dvorak->qwerty)
(puthash "3" "3" dvorak->qwerty)
(puthash "4" "4" dvorak->qwerty)
(puthash "5" "5" dvorak->qwerty)
(puthash "6" "6" dvorak->qwerty)
(puthash "7" "7" dvorak->qwerty)
(puthash "8" "8" dvorak->qwerty)
(puthash "9" "9" dvorak->qwerty)
(puthash "0" "0" dvorak->qwerty)
(puthash "[" "-" dvorak->qwerty)
(puthash "]" "=" dvorak->qwerty)

(puthash "'" "q" dvorak->qwerty)
(puthash "," "w" dvorak->qwerty)
(puthash "." "e" dvorak->qwerty)
(puthash "p" "r" dvorak->qwerty)
(puthash "y" "t" dvorak->qwerty)
(puthash "f" "y" dvorak->qwerty)
(puthash "g" "u" dvorak->qwerty)
(puthash "c" "i" dvorak->qwerty)
(puthash "r" "o" dvorak->qwerty)
(puthash "l" "p" dvorak->qwerty)
(puthash "/" "{" dvorak->qwerty)
(puthash "?" "{" dvorak->qwerty)
(puthash "=" "]" dvorak->qwerty)
(puthash "+" "}" dvorak->qwerty)
(puthash "\\" "\\" dvorak->qwerty)
(puthash "|" "|" dvorak->qwerty)

(puthash "a" "a" dvorak->qwerty)
(puthash "o" "s" dvorak->qwerty)
(puthash "e" "d" dvorak->qwerty)
(puthash "u" "f" dvorak->qwerty)
(puthash "i" "g" dvorak->qwerty)
(puthash "d" "h" dvorak->qwerty)
(puthash "h" "j" dvorak->qwerty)
(puthash "t" "k" dvorak->qwerty)
(puthash "n" "l" dvorak->qwerty)
(puthash "s" ";" dvorak->qwerty)
(puthash "S" ":" dvorak->qwerty)
(puthash "-" "'" dvorak->qwerty)
(puthash "_" "\"" dvorak->qwerty)

(puthash ";" "z" dvorak->qwerty)
(puthash "q" "x" dvorak->qwerty)
(puthash "j" "c" dvorak->qwerty)
(puthash "k" "v" dvorak->qwerty)
(puthash "x" "b" dvorak->qwerty)
(puthash "b" "n" dvorak->qwerty)
(puthash "m" "m" dvorak->qwerty)
(puthash "w" "," dvorak->qwerty)
(puthash "W" "<" dvorak->qwerty)
(puthash "v" "." dvorak->qwerty)
(puthash "V" ">" dvorak->qwerty)
(puthash "z" "/" dvorak->qwerty)
(puthash "Z" "?" dvorak->qwerty)

(puthash "~" "~" dvorak->qwerty)
(puthash "!" "!" dvorak->qwerty)
(puthash "@" "@" dvorak->qwerty)
(puthash "#" "#" dvorak->qwerty)
(puthash "$" "$" dvorak->qwerty)
(puthash "%" "%" dvorak->qwerty)
(puthash "^" "^" dvorak->qwerty)
(puthash "&" "&" dvorak->qwerty)
(puthash "*" "*" dvorak->qwerty)
(puthash "(" "(" dvorak->qwerty)
(puthash ")" ")" dvorak->qwerty)
(puthash "{" "_" dvorak->qwerty)
(puthash "}" "+" dvorak->qwerty)

(defun to-qwerty (key)
  (let ((next (let () 
		(message "%s" key) 
		(string (read-char-exclusive)))))
    (concat key (gethash next dvorak->qwerty))))

(maphash 
 (lambda (key val) 
   (define-key key-translation-map (concat "\C-" key)
     '(lambda (prompt) 
	(to-qwerty (concat "\C-" (gethash key dvorak->qwerty))))))
 dvorak->qwerty)
